/* file lplcmin.c */
#define eps 1.0e-14
#define mMax 10

#include <math.h>
#include <stdio.h>
#include <stdlib.h>

#define min(a,b)  (a)>(b) ? (b) : (a)
#define max(a,b)  (a)<(b) ? (b) : (a)


typedef struct{ float x,y; }point;
typedef long triangle[3];
typedef struct{ int ns, nt;
 				point *q;
 				triangle *me;
 				int *ngt;
 				int* ng;
			   }triangulation;
			   
int   litT(char* nomfic,triangulation* t);
int	  litF(char* nomfic,int ns,float* tab);
int	  ecritF(char* nomfic,int ns,float* tab);
/*void  calBand(triangulation* t);
void  verif1(int ns,int nBand,float* a);
*/float deter (float a,float c,float e,float b,
            float d,float f);
float E(triangulation* t, float* phi, float* f);
float dEdPhi(triangulation* t, float* phi, float* f, 
          	float* gradE);
float rho(triangulation* t,float* gradE, float* hConj, 
			float* hConjm);
           
/*----------------------------------------------------*/
int  litT(char* nomfic,triangulation* t)
/*----------------------------------------------------*/
{ int i,a,b,c; FILE *f;
  if(f=fopen(nomfic, "r"), !f) return 1;
  fscanf(f,"%d	%d\n", &t->ns,&t->nt);
  t->q = (point*)calloc(t->ns,sizeof(point));
  t->me = (triangle*)calloc(t->nt,sizeof(triangle));
  t->ng = (int*)calloc(t->ns,sizeof(int));
  t->ngt = (int*)calloc(t->nt,sizeof(int));
  for(i=0; i<t->ns; i++)
    fscanf(f,"%e	%e	%d\n", 
    	&t->q[i].x, &t->q[i].y, &t->ng[i]);
  for(i=0; i<t->nt; i++)
    { fscanf(f,"%d	%d	%d	%d\n",&a,&b,&c, &t->ngt[i]);
      t->me[i][0] = a-1; t->me[i][1] = b-1; 
      t->me[i][2] = c-1;
    }
  fclose(f);
  return 0;
 } 
 
/*----------------------------------------------------*/
int		litF(char* nomfic,int ns,float* tab)
/*----------------------------------------------------*/
/* Ecriture du tableau tab dans le fichier nomfic     */ 
{	int i, nss;  FILE* f;
   if(f=fopen(nomfic, "r"), !f) return 1;
   fscanf(f,"%d\n", &nss);
   if(ns != nss) 
    { printf("erreur de dimension\n"); return 1;}
   for(i=0; i<ns; i++) fscanf(f,"%e\n", &tab[i]);      
   fclose(f);
   return 0;
}

/*----------------------------------------------------*/
int		ecritF(char* nomfic,int ns,float* tab)
/*----------------------------------------------------*/
/* Ecriture du tableau tab dans le fichier nomfic     */ 
{	int i;  FILE* f;
   if(f=fopen(nomfic, "w"), !f) return 1;
   fprintf(f,"%d\n", ns);
   for(i=0; i<ns; i++) fprintf(f,"%e\n", tab[i]);      
   fclose(f);
   return 0;
}

/*----------------------------------------------------*/
float deter (float a,float c,float e,float b,
               float d,float f)
/*----------------------------------------------------*/
{
       return (a-e)*(d-f) - (b-f)*(c-e);
}

/* ----------------------------------------------------------*/
float E(triangulation* t, float* phi, float* f)
/* ----------------------------------------------------------*/
{
 float xi1, xi2, xi3, yi1, yi2, yi3, phii1, phii2, phii3 ;
 float fk, aire2Tk, gradFx, gradFy, ee;
 int k,i1,i2,i3;

  ee = 0.;
  for(k=0;k<t->nt;k++)	
  {
    i1 = t->me[k][0]; i2 = t->me[k][1]; i3 = t->me[k][2];
    xi1=t->q[i1].x;   xi2=t->q[i2].x; 	xi3=t->q[i3].x;                                              
    yi1=t->q[i1].y;   yi2=t->q[i2].y;   yi3=t->q[i3].y;
    phii1=phi[i1];    phii2=phi[i2]; 	phii3=phi[i3];
    fk=(f[i1]+f[i2]+f[i3])/3.;                                              
    aire2Tk = deter(xi1,xi2,xi3,yi1,yi2,yi3) ;
    gradFx =deter(phii1,phii2,phii3,yi1,yi2,yi3)/aire2Tk;
    gradFy =deter(xi1,xi2,xi3,phii1,phii2,phii3) /aire2Tk;
    ee += 0.5*fabs(aire2Tk)*( (gradFx*gradFx + gradFy*gradFy)/2.  
    	 -fk*(phii1+phii2+phii3)/3. );
   }
 return ee;
}

/* ----------------------------------------------------------*/
float dEdPhi(triangulation* t,float* phi,float* f,float* gradE)
/* ----------------------------------------------------------*/
{ 
 float w[3], xi1, xi2, xi3, yi1, yi2, yi3, phii1, phii2, phii3 ;
 float fk, aire2Tk, gradFx, gradFy, g2h, gradWix, gradWiy;
 int i,k,j,l,i1,i2,i3;

 for(i=0;i<t->ns;i++) gradE[i] = 0;
  for(k=0;k<t->nt;k++)	
  {
    i1 = t->me[k][0]; 	i2 = t->me[k][1];  	i3 = t->me[k][2];
    xi1=t->q[i1].x;    	xi2=t->q[i2].x;   	xi3=t->q[i3].x;                                              
    yi1=t->q[i1].y;  	yi2=t->q[i2].y;  	yi3=t->q[i3].y;
    phii1=phi[i1];  	phii2=phi[i2]; 		phii3=phi[i3];

    fk=(f[i1]+f[i2]+f[i3])/3.;                                              
    aire2Tk = deter(xi1,xi2,xi3,yi1,yi2,yi3) ;
    gradFx = deter(phii1,phii2,phii3,yi1,yi2,yi3)/aire2Tk;
    gradFy = deter(xi1,xi2,xi3,phii1,phii2,phii3) /aire2Tk;

    for(j=0;j<3;j++)
    {
       i = t->me[k][j];
       if ( t->ng[i]== 0 ) 
       {
       	for(l=0;l<3;l++) w[l] = 0.0;
       	w[j] = 1.0;
       	gradWix = deter(w[0],w[1],w[2],yi1,yi2,yi3) / aire2Tk;
       	gradWiy = deter(xi1,xi2,xi3,w[0],w[1],w[2]) / aire2Tk;
       	gradE[i] += (gradFx*gradWix + gradFy*gradWiy 
                      - fk/3) *fabs(aire2Tk)/2;
       }
    }
   }
  g2h=0.0; for(i=0;i<t->ns;i++) g2h += gradE[i] * gradE[i];
  return g2h;
}

/* ----------------------------------------------------*/
float rho(triangulation* t,float* gradE, float* hConj, 
           float* hConjm)
/* ----------------------------------------------------*/
{
  float rh, DEhConj=0.;
  int i;  
  	for(i=0; i<t->ns;i++) 
  	{
  		hConjm[i]=0.;
  		DEhConj += gradE[i]*hConj[i];
  	}
 	rh = -0.5*DEhConj/E(t, hConj,hConjm) ;
  return rh;
}


/* ----------------------------------------------------*/
void main()
/* ----------------------------------------------------*/
{
	int i,m;
	float g2h, eps1,gamma, g2hm=1, ro, E1;
	float *phi, *f, *gradE, *hConj, *hConjm;
	triangulation t;
	char* nomfic = calloc(20, sizeof(char));
	
	printf("nom du fichier maillage  "); 
	scanf("%s",nomfic);
	litT(nomfic,&t);

  	f = (float*)calloc(t.ns,sizeof(float));
  	phi = (float*)calloc(t.ns,sizeof(float));
  	gradE = (float*)calloc(t.ns,sizeof(float));
  	hConj = (float*)calloc(t.ns,sizeof(float));
  	hConjm = (float*)calloc(t.ns,sizeof(float));
	
	printf("nom du fichier pour f  ");
	scanf("%s",nomfic);
	litF(nomfic,t.ns,f);
	printf("nom du fichier pour phi  ");
	scanf("%s",nomfic);
	litF(nomfic,t.ns,phi);

	printf("iter  energie        ro          g2h\n");
	for(m=0; m<mMax; m++)
	{
		g2h = dEdPhi(&t,phi,f,gradE);
		if(m==0) eps1 =  eps*g2h;
        gamma = g2h / g2hm;	
        for(i=0;i<t.ns;i++) 
          hConj[i] =-gradE[i] + gamma*hConjm[i];
        ro = rho(&t,gradE,hConj,hConjm);
        E1 = E(&t,phi,f);
        printf("%d	%e	%e	%e\n",m,E1,ro,g2h);
        if(g2h<eps1) break;
        for(i=0;i<t.ns;i++)
        {
          phi[i] +=  ro* hConj[i];
          hConjm[i] = hConj[i];
		 }
        g2hm = g2h;
    }
   printf("nom du fichier de stockage de la  solution approchee\n");
   scanf("%s", nomfic);
   ecritF(nomfic,t.ns,phi) ;
   printf("fin\n");    
}