/*  file: tinytri.c   */
/* Ce programme construit le maillage de la triangulation
   minuscule et ecrit les donnees du probleme modele  */

#include <math.h>
#include <stdio.h>
#include <stdlib.h>

char* tfile = "tinyt.dta";
char* ffile = "tinyf.dta";
char* gfile = "tinyg.dta";

typedef struct{ float x,y; }point;
typedef long triangle[3];
typedef struct{ int ns, nt;
 				point *q;
 				triangle *me;
 				int *ngt;
 				int* ng;
			   }triangulation;
int  ecritT(char* nomfic,triangulation* t);
int	 ecritF(char* nomfic,int ns,float* tab);
 

/*--------------------------------------------------*/
int  ecritT(char* nomfic,triangulation* t)
/*--------------------------------------------------*/
{int i,a,b,c; FILE *f;
  if(f=fopen(nomfic, "w"), !f) return 1;
  fprintf(f,"%d	%d\n", t->ns,t->nt);
  for(i=0; i<t->ns; i++)
    fprintf(f,"%e	%e	%d\n", 
    	t->q[i].x, t->q[i].y, t->ng[i]);
  for(i=0; i<t->nt; i++)
    {	a = 1+t->me[i][0]; b = 1+t->me[i][1]; 
      c = 1+t->me[i][2];
    	fprintf(f,"%d	%d	%d	%d\n",a,b,c, t->ngt[i]);
    }
  fclose(f);
  return 0;
 } 
/*---------------------------------------------------*/
int		ecritF(char* nomfic,int ns,float* tab)
/*---------------------------------------------------*/
/* Ecriture du tableau tab dans le fichier nomfic    */ 
{	int i;  FILE* f;
   if(f=fopen(nomfic, "w"), !f) return 1;
   fprintf(f,"%d\n", ns);
   for(i=0; i<ns; i++) fprintf(f,"%e\n", tab[i]);      
   fclose(f);
   return 0;
}

/*----------------------------------------------------*/
void main(void)
/*----------------------------------------------------*/
{
  triangulation t;
  float *f;	   /* fonction source */
  float *phi; /* conditions aux bords & initialisation */
  int i;
	t.ns = 8;
	t.nt = 8;
	t.q = (point*)calloc(t.ns,sizeof(point));
	t.q[0].x = 0;	t.q[0].y = 0;
	t.q[1].x = 0;	t.q[1].y = 1;
	t.q[2].x = 1;	t.q[2].y = 1;
	t.q[3].x = 1;	t.q[3].y = 0;
	t.q[4].x =.5;	t.q[4].y =.5;
	t.q[5].x = 2;	t.q[5].y = 0;
	t.q[6].x = 2;	t.q[6].y = 1;
	t.q[7].x =1.5;	t.q[7].y =.5;
	t.me = (triangle*)calloc(t.nt,sizeof(triangle));
	t.me[0][0] = 0;	t.me[0][1] = 4;	t.me[0][2] = 1;
	t.me[1][0] = 0;	t.me[1][1] = 3;	t.me[1][2] = 4;
	t.me[2][0] = 4;	t.me[2][1] = 3;	t.me[1][2] = 7;
	t.me[3][0] = 2;	t.me[3][1] = 1;	t.me[3][2] = 4;
	t.me[4][0] = 7;	t.me[4][1] = 2;	t.me[4][2] = 4;
	t.me[5][0] = 3;	t.me[5][1] = 5;	t.me[5][2] = 7;
	t.me[6][0] = 5;	t.me[6][1] = 6;	t.me[6][2] = 7;
	t.me[7][0] = 7;	t.me[7][1] = 6;	t.me[7][2] = 2;
	t.ng = (int*)calloc(t.ns,sizeof(int));
	t.ng[0] = 1; t.ng[1] = 1; t.ng[2] = 1; t.ng[3] = 1;
	t.ng[4] = 0; t.ng[5] = 1; t.ng[6] = 1; t.ng[7] = 0;
	t.ngt = (int*)calloc(t.nt,sizeof(int));
	f = (float*)calloc(t.ns,sizeof(float));
	phi = (float*)calloc(t.ns,sizeof(float));
	for(i=0;i<t.ns;i++)f[i]=1;
	ecritT(tfile,&t);         
	ecritF(ffile,t.ns,f) ;
	ecritF(gfile,t.ns,phi);
	printf("3 fichier generes: %s, %s, %s \n",tfile,ffile,gfile);
}
 
