typedef float base;

class Vector: public A<base> { public:
  ~Vector(){ delete [] cc; size=0; cc=0;}
  Vector (): A<base> () {};
  Vector (int n): A<base> (n) {};
  Vector ( const Vector& v );
  const Vector& operator = ( const Vector& v);
  const Vector& operator = ( const float x);
  base & operator [] ( int i) const { myassert((i>=0)&&(i<size));
  									  return cc[i]; }
  float norm () const;
  Vector& operator /=(const float x);
  Vector& operator +=(const Vector& x);
  Vector& operator -=(const Vector& x);
  friend Vector operator * (const base, const Vector& );
  friend float operator * (const Vector& , const Vector& );
  friend Vector operator - (const Vector& , const Vector& );
  friend Vector operator + (const Vector& , const Vector& );
  friend ostream& operator << ( ostream&, Vector& );
  //  etc: other operators here
};

class Matrix  { public:
  int notfact;  // indicates if it is factorized or not
  int m,n;  	// nb of rows and colums
  Vector* ccc;  // array of columns
//  void LU();
  Matrix ( int mm, int nn );
  Matrix ( Matrix& a );
  friend Vector operator * (const Matrix& , const Vector& ); 
  Vector& operator()(int j) {	Vector& b = ccc[j]; return b;}  // returns column j
  float& operator()(int i, int j) // access function 
  { 
  		myassert(ccc && (i>=0)&&(i<m)&&(j>=0)&&(j<n));
  		return ccc[j].cc[i];
  }	
 };

class Bandmatrix: public A<float> { 
public: 
int bdth,n;							// bandwidth and size
Bandmatrix(int n1,int bdth1):A<float>((long)(2*bdth1*(long)n1+(long)n1)){ n=n1; bdth = bdth1;}
~Bandmatrix(){ }
float& operator()(int i, int j)  // access function
			{ long k = (long)n*(i-j + bdth) + j;
	 		  myassert(cc && (k>=0)&&(k<size));
	 		  return cc[k];
	 		}
friend Vector operator * (const Bandmatrix& , const Vector& ); 
friend ostream& operator << (ostream& os, Bandmatrix& a);
};

float gaussband (Bandmatrix& a, A<float>& x, int first);

