#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define M 100
#define dx  0.1
#define kmax 20

typedef enum{ texte,graphique } affiche;

typedef struct { 
 	float kappa, theta0, theta1, theta2; 
 	float alpha[M];
 } data;

void init( float* theta, data* d);
void relax( float* theta, data* d);
void showresult( affiche mode, float* theta);
void readdata(data* d);

void readdata(data* d)
{ int i;
	printf( "entrer kappa:"); 	scanf("%f",&d->kappa);
	printf("entrer theta0:"); 	scanf("%f",&d->theta0);
	printf( "entrer theta1:"); 	scanf("%f",&d->theta1);
	printf( "entrer theta2:"); 	scanf("%f",&d->theta2);
	for(i=0; i< M; i++) d->alpha[i] = i*i/(M-1.)/(M-1.);
}

void init( float* theta, data* d)
{ int i;
  for(i = 0; i< M; i++) 
   theta[i]=d->theta1*(M-1-i)/(M-1.)+d->theta2*i/(M-1.);
}

void relax( float* theta, data* d)
{ int i;
  float kappadx2 = d->kappa / dx / dx;
   for( i = 1; i< M-1; i++)
  	theta[i] = (kappadx2 * (theta[i+1] +theta[i-1])
  	+ d->alpha[i] * d->theta0)/(d->alpha[i]+2 *kappadx2);
}

void showresult( affiche mode, float* theta)
{ int i;
  if(mode==graphique) 
  /* dependant machine: exemple en commentaire */
  {	/* MoveTo( 0, (int)(theta[0])); */
  	for( i = 1; i< M; i++) 
  	/*	LineTo( i, (int)( theta[i])); */
  } else if(mode==texte)   	
  	 	  for( i = 0; i< M; i++) 
  	 	     printf("theta[%d]=%f\n",i,theta[i]);
}

void main()
{ int k;
	float* theta = (float*)calloc(M, sizeof(float));
	data d;

	readdata(&d);
	init(theta, &d);

	for (k = 0; k < kmax; k++)
   		relax(theta, &d);

	showresult(texte, theta);
	printf("fin\n");

}