#include <iostream.h>
#include <stdlib.h>
#include <math.h>
#include <iostream.h>

const int M = 100;
const float dx = 0.1;
const int kmax = 20;

typedef enum{ texte,graphique } affiche;

class data
 { 
 	public:
 	float kappa, theta0, theta1, theta2; 
 	float alpha[M];
 	void read();
 };

void init( float* theta, data& d);
void relax( float* theta, data& d);
void showresult( affiche mode, float* theta);

void data::read()
{
	cout << "enter kappa:"; 	cin >>	kappa;
	cout << "enter theta0:"; 	cin >> theta0;
	cout << "enter theta1:"; 	cin >> theta1;
	cout << "enter theta2:"; 	cin >> theta2;
	for(int i = 0; i< M ; i++) alpha[i] = i*i/(M-1.)/(M-1.);
}

void init( float* theta, data& d)
{
	for(int i = 0; i< M; i++) 
		theta[i]=d.theta1 * (M-1-i)/(M-1.) + d.theta2 * i/(M-1.);
}

void relax( float* theta, data& d)
{
  const float kappadx2 = d.kappa / dx / dx;
  for(int i = 1; i< M-1; i++)
  	theta[i] = (kappadx2 * (theta[i+1] +theta[i-1])
  	+ d.alpha[i] * d.theta0) / (d.alpha[i]+  2 * kappadx2);
}

void showresult( affiche mode, float* theta)
{ int i;
  if(mode==graphique) 
  {	MoveTo( 0, (int)(theta[0])); 
  	for( i = 1; i< M; i++) 
  		LineTo( i, (int)( theta[i]));
  } else if(mode==texte)   	
  		for( i = 0; i< M; i++) cout<<theta[i]<<endl;  
}

void main()
{
	float* theta = new float[M];
	data d;

	d.read();
	init(theta, d);

	for (int k = 0; k < kmax; k++)
   		relax(theta, d);

	showresult(texte, theta);
	cout<<"fin";

}