c  file: doCarreTri.for
c
      PROGRAM MailCarre
C     ---------------------  
C                             
C Ce programme construit le maillage de la triangulation
C minuscule et stocke les donnees du probleme modele
C
C     tableaux:
C     --------- 
C     maillage:
C       q:coordonnees des sommets du maillage
C       me:numerotation des sommets des triangles
C       ng:tableau indiquant si un sommet est sur la frontiere
C          ($ng(i)=1$) ou non ($ng(i)=0$).
C     donnees:
C       f(nsMax):second membre du Laplacien,
C       phi(nsMax):conditions aux limites de Dirichlet
C
C     fichiers:
C     ---------
C       TriCarre.dta:nom du fichier de stockage de la triangulation
C          ainsi que de f et de phi
C
C
      PARAMETER (nsMax=1600,ntMax=3200)
      DIMENSION q(2,nsMax),me(3,ntMax),ng(nsMax)
      DIMENSION f(nsMax),phi(nsMax)
C     
      write(*,*) 'nombre de points en abscisse (40 maxi)'
      read(*,*) nx
      write(*,*) 'nombre de points en ordonnee (40 maxi)'
      read(*,*) ny
C
      ns=nx*ny
      nxm=nx-1
      nym=ny-1
      nt=2*nxm*nym 
      dx=1./(nx-1.)
      dy=1./(ny-1.)
C 
C definition de q, ng
C
      DO 1 j=1,ny
        i1=(j-1)*nx
        DO 1 i=1,nx
          k=i1+i
          q(1,k)=(i-1)*dx
          q(2,k)=(j-1)*dy
          IF((j.EQ.1).OR.(j.EQ.ny).OR.(i.EQ.1).OR.(i.EQ.nx)) THEN
            ng(k)=1
          ELSE
            ng(k)=0
          ENDIF 
1     CONTINUE
C
C definition de me
C
      nxm2=2*nxm
      DO 10 l=1,nym
        k1=(l-1)*nxm2
        i1=(l-1)*nx
        DO 10 k=1,nxm2-1,2
          it=k1+k
            is=1+(k-1)/2
            is1=i1+is
            me(1,it)=is1
            me(2,it)=is1+1
            me(3,it)=is1+1+nx
          itp=it+1
            is1=is1+1+nx
            me(1,itp)=is1
            me(2,itp)=is1-1
            me(3,itp)=is1-1-nx
10    CONTINUE
C
C definition de f,phi (phi initialisee a 0 pour les sommets internes)
C     
      DO 20 i=1,ns 
        phi(i)=0.
20    CONTINUE
      DO 21 i=1,ns
        x=q(1,i)
        y=q(2,i)
        xx=x*x
        yy=y*y
        rr=xx+yy
        f(i)=-16*rr
        IF(ng(i).EQ.1) phi(i)= rr*rr
21    CONTINUE
C
C Ecriture dans le fichier TriCarre.dta
C
      OPEN(UNIT=13, file='TriCarre.dta')
      ngt=0
      write(13,*) ns,nt
      DO 100 i=1,ns
        write(13,*) q(1,i),q(2,i),ng(i)
100     CONTINUE
      DO 110 i=1,nt
        write(13,*) me(1,i),me(2,i),me(3,i),ngt
110     CONTINUE
      DO 120 i=1,ns
        write(13,*) f(i)
120   CONTINUE
      DO 130 i=1,ns
        write(13,*) phi(i)
130   CONTINUE
      CLOSE(13)
C
      END 
