c  fichier: TinyTri.for
c
      PROGRAM MailTiny
C     ---------------------  
C
C Ce programme construit le maillage de la triangulation
C minuscule et stocke les donnees du probleme modele.
C
C     tableaux:
C     --------- 
C     maillage:
C       q:coordonnees des sommets du maillage,
C       me:numerotation des sommets des triangles
C       ng:tableau indiquant si un sommet est 
C         interne (ng(i)=0) ou sur la frontiere.
C
C     donnees:
C       f: second membre du Laplacien,
C       phi:conditions aux limites de Dirichlet. 
C
C     fichiers:
C     ---------
C       TinyTri.dta:nom du fichier de stockage de la 
C         triangulation,
C       nomfic:nom du fichier de stockage de f ou de phi
C              (le nom de ce fichier est donne par 
C               l'utilisateur au moment de l'execution
C               du programme).
C
C     sous-programmes:
C     ----------------
C       ecritT:ecriture du maillage dans un fichier
C         dont le nom est precise par l"utilisateur
C         au moment de l"execution du programme; on
C         suggere ici de l"appeller TinyTri.dta.
C       ecritF:ecriture du tableau tab dans le fichier
C         dont le nom est precise par l"utilisateur
C         au moment de l"execution du programme.
C
C
      PARAMETER (nsMax=30,ntMax=60)
      DIMENSION f(nsMax),phi(nsMax)
      CHARACTER*20 nomfic
C     
      ns=8
      nt=8
      DATA q/3*0.,4*1.,0.,2*.5,2.,0.,2.,1.,1.5,.5/            
      DATA me/1,5,2, 1,4,5, 5,4,8, 3,2,5,
     >          8,3,5, 4,6,8, 6,7,8, 8,7,3/      
      DATA ng/4*1,0,2*1,0/
      DATA f/ns*0./                               
      DATA phi/ns*0./ 
C                                    
C  
      write(*,*) 'nom du fichier du maillage'
      write(*,*) '(exemple traite: TinyTri.dta)'
      read(*,'(a)') nomfic
      CALL ecritT(nomfic,ns,nt,q,ng,me,ngt)         
      write(*,*) 'nom du fichier de stockage de f'
      write(*,*) '(second membre du Laplacien)'
      read(*,'(a)') nomfic
      CALL ecritF(nomfic,ns,f) 
      write(*,*) 'nom du fichier de stockage de phi'
      write(*,*) '(conditions aux limites de Dirichlet)'
      read(*,'(a)') nomfic  
      CALL ecritF(nomfic,ns,phi)
C
      END 
C
C--------------------------------------------------------
      SUBROUTINE ecritT(nomfic,ns,nt,q,ng,me,ngt)
C--------------------------------------------------------
C
C Ecriture du maillage dans le fichier nomfic
C
C
      CHARACTER*20 nomfic 
      DIMENSION q(2,ns),me(3,nt),ng(ns)
C                                    
      OPEN(UNIT=13, file=nomfic)
      ngt=0
      write(13,*) ns,nt
      DO 1 i=1,ns
        write(13,*) q(1,i),q(2,i),ng(i)
1     CONTINUE
      DO 2 i=1,nt
        write(13,*) me(1,i),me(2,i),me(3,i),ngt
2     CONTINUE
      CLOSE(13)
C
      END 
C
C--------------------------------------------------------
      SUBROUTINE ecritF(nomfic,ns,tab)
C--------------------------------------------------------
C
C Ecriture du tableau tab dans le fichier nomfic  
C
C
      CHARACTER*20 nomfic 
      DIMENSION tab(ns)
C
      OPEN(UNIT=13, file=nomfic)
      write(13,*) ns
      DO 1 i=1,ns              
        write(13,*) tab(i)      
1     CONTINUE
      CLOSE(13)
C
      END
