C  fichier: minEdE.for 
C
C--------------------------------------------------------
      SUBROUTINE dEdPhi(q,me,ng,phi,f,ns,nt,gradE,g2h)
C--------------------------------------------------------
C Calcule le gradient de la fonctionnelle energie en chaque 
C sommet du maillage et le stocke dans le tableau gradE.
C
C Calcule aussi le carre de la norme euclidienne du 
C gradient de E et le stocke dans le scalaire g2h.
C
C     tableaux:
C     --------- 
C     maillage:
C       q(2,ns):coordonnees des sommets du maillage,
C       me(3,nt):numerotation des sommets des triangles,
C       ng(ns):tableau indiquant si un sommet est 
C         interne (ng(i)=0) ou non.
C
C     donnees:
C       f(ns):second membre du Laplacien,
C       phi(ns):solution approchee.
C
C     sortie:
C       gradE(ns):gradient de la fonctionnelle E,
C
C     autres tableaux: 
C       w(3):fonction de base.
C
      DIMENSION q(2,ns),me(3,nt), ng(ns)
      DIMENSION phi(ns),f(ns),gradE(ns),w(3)
C
      DO 1 i = 1, ns	
        gradE(i) = 0
1     CONTINUE	
      DO 2 k = 1, nt	
        i1 = me(1,k)
        i2 = me(2,k)
        i3 = me(3,k)
        xi1=q(1,i1)                                              
        xi2=q(1,i2)                                              
        xi3=q(1,i3)                                              
        yi1=q(2,i1)                                              
        yi2=q(2,i2)                                              
        yi3=q(2,i3)
        phii1=phi(i1)
        phii2=phi(i2)
        phii3=phi(i3)
C
        fk=(f(i1)+f(i2)+f(i3))/3.                                              
        aire2Tk = deter(xi1,xi2,xi3,yi1,yi2,yi3) 
        gradFx = deter(phii1,phii2,phii3,yi1,yi2,yi3)
     >                    /aire2Tk
        gradFy = deter(xi1,xi2,xi3,phii1,phii2,phii3)
     >                    /aire2Tk
C
        DO 3 j=1,3
          i = me(j,k)
          IF ( ng(i).EQ.0 ) THEN
            DO 4 l = 1,3
              w(l) = 0.0
4           CONTINUE
            w(j) = 1.0
            gradWix = deter(w(1),w(2),w(3),yi1,yi2,yi3)
     >                          /aire2Tk
            gradWiy = deter(xi1,xi2,xi3,w(1),w(2),w(3))
     >                          /aire2Tk
            gradE(i) =  gradE(i)+ (gradFx*gradWix
     >                 + gradFy*gradWiy - fk/3)
     >                   *abs(aire2Tk)/2.
          ENDIF
3       CONTINUE
2     CONTINUE
      g2h=0.0
      DO 5 i=1,ns
        gradEi=gradE(i)
        g2h=g2h+gradEi*gradEi
5     CONTINUE
      RETURN
      END
