C  fichier: minErho.for
C
C---------------------------------------------------------
        FUNCTION rho(q,me,ns,nt,phi,gradE,hConj,hConjm)
C---------------------------------------------------------
C Cette fonction calcule le scalaire rho qui minimise la 
C fonctionnelle energie sur la droite passant par
C phi et de vecteur directeur hConj. 
C
C     tableaux:
C     --------- 
C     maillage:
C       q(2,ns):coordonnees des sommets du maillage,
C       me(3,nt):numerotation des sommets des triangles.
C     entree:
C       gradE(ns):gradient, en chacun des sommets du
C          maillage, de la fonctionnelle E,
C       phi(ns):tableau contenant les valeurs de la 
C         solution approchee en chacun des sommets
C         du maillage,  
C       hConj(ns):direction de descente.
C     autre tableau:
C       hConjm(ns):tableau nul (utilisation de la 
C         fonction E pour le calcul du denominateur de rho)
C
C
      DIMENSION q(2,ns),me(3,nt)
       DIMENSION phi(ns),gradE(ns),hConj(ns),hConjm(ns) 
C
      DEhConj=0.
      DO 1 i=1,ns
        hConjm(i)=0.
1     CONTINUE
      DO 2 i=1,ns
        DEhConj=DEhConj+gradE(i)*hConj(i)
2     CONTINUE
C		
      rho = -0.5*DEhConj/E(q,me,hConj,hConjm,ns,nt) 
C
      RETURN
      END
