C  fichier: utilP1.for
C
C--------------------------------------------------------
      SUBROUTINE ecritT(nomfic,ns,nt,q,ng,me,ngt)
C--------------------------------------------------------
C
C Ecriture du maillage dans le fichier nomfic
C
C
      CHARACTER*20 nomfic 
      DIMENSION q(2,ns),me(3,nt),ng(ns)
C                                    
      OPEN(UNIT=13, file=nomfic)
      ngt=0
      write(13,*) ns,nt
      DO 1 i=1,ns
        write(13,*) q(1,i),q(2,i),ng(i)
1     CONTINUE
      DO 2 i=1,nt
        write(13,*) me(1,i),me(2,i),me(3,i),ngt
2     CONTINUE
      CLOSE(13)
C
      END 
C
C--------------------------------------------------------
      SUBROUTINE ecritF(nomfic,ns,tab)
C--------------------------------------------------------
C
C Ecriture du tableau tab dans le fichier nomfic  
C
C
      CHARACTER*20 nomfic 
      DIMENSION tab(ns)
C
      OPEN(UNIT=13, file=nomfic)
      write(13,*) ns
      DO 1 i=1,ns              
        write(13,*) tab(i)      
1     CONTINUE
      CLOSE(13)
C
      END
C
C--------------------------------------------------------
      SUBROUTINE litT(nomfic,ns,nt,q,ng,me,ngt)
C--------------------------------------------------------
C 
C Ce sous-programme lit la triangulation stocke dans
C  le fichier nomfic. 
C Si necessaire, le tableau ngt contient l'indice de la 
C region ou se trouve le triangle et doit donc etre  
C declare comme un tableau dans le programme principal; 
C sinon, ngt est un simple scalaire (ngt=0).
C
C
      CHARACTER*20 nomfic
      DIMENSION q(2,ns),me(3,nt),ng(ns),ngt(1)
C
      OPEN(UNIT=13,file=nomfic,STATUS='OLD')
      read(13,*) ns,nt
      DO 1 i=1,ns				
        read(13,*) q(1,i),q(2,i),ng(i)
1     CONTINUE
      DO 2 i=1,nt
        read(13,*) me(1,i), me(2,i), me(3,i), ngti
        IF (ngti.NE.0)ngt(i)=ngti
2     CONTINUE
      CLOSE(13)
C
      END
C
C--------------------------------------------------------
      SUBROUTINE litF(nomfic,ns,tab)
C--------------------------------------------------------
C 
C Ce sous-programme lit le contenu du tableau tab, 
C de taille ns, qui est stocke dans le fichier nomfic.
C
C
      CHARACTER*20 nomfic
      DIMENSION tab(ns)
C
      OPEN(UNIT=13,file=nomfic,STATUS='OLD')
      read(13,*) ns
      DO 1 i=1,ns
        read(13,*) tab(i)
1     CONTINUE
      CLOSE(13)
C
      END
C
C--------------------------------------------------------
       SUBROUTINE calBand(me,ng,nt,ns,nBand)
C--------------------------------------------------------
C Ce sous-programme calcule la largeur de bande de la
C matrice du systeme lineaire: $nBand=max|i-j|$ ou $q^i, q^j$
C sont les sommets d'un meme triangle.
C
C
      DIMENSION me(3,nt),ng(ns)
      nBand=0
      DO 2 k=1,nt
        DO 2 ir=1,3
          jr=mod(ir,3)+1
          i=me(ir,k)
          j=me(jr,k)
          nB1=abs(j-i)
        IF(nBand.LT.nB1) nBand=nB1
2     CONTINUE
      END
C
C--------------------------------------------------------
      SUBROUTINE verif1(ns,nBand,a)
C--------------------------------------------------------
C Ce sous-programme verifie que la somme des elements
C de la matrice a sur une ligne est egale a 0.
C Il devrait etre appelle avant de mettre les conditions
C aux limites de Dirichlet.
C
C
      DIMENSION a(*)
      write(*,*) ns,nBand
      DO 1 i=1,ns
        sum1=0.
        jmin=max(1,i-nBand)
        DO 2 j=jmin,i-1
          sum1=sum1 +a((i-1)*nBand+j)
2       CONTINUE
        jmax=min(ns,i+nBand)
        sum2=0.
        DO 3 j=i+1,jmax
          sum2=sum2 +a((j-1)*nBand+i)
3       CONTINUE
          s11=a((i-1)*nBand+i)
        IF((sum1+sum2+s11).NE.0.) 
     >  write(*,*)i,j,jmin,jmax,sum1,sum2,s11
1     CONTINUE
      END

C
C----------------------------------------------------
        FUNCTION errH10(q,me,phi,f,ns,nt)
C----------------------------------------------------
C Cette fonction calcule l'erreur $H^1_0$ entre la solution
C exacte (stockee dans le tableau f) et la solution 
C calculee (stockee dans le tableau phi) pour un Laplacien
C avec conditions aux limites de Dirichlet   
C        $Erreur=\int_\Omega(|\nabla (\phi-f)|^2 )$
C
C 
       DIMENSION phi(ns),f(ns),me(3,nt),q(2,ns)
C
       E = 0.
       DO 1 k = 1,nt	
       i1 = me(1,k)
       i2 = me(2,k)
       i3 = me(3,k)
         err1=phi(i1)-f(i1)
         err2=phi(i2)-f(i2)
         err3=phi(i3)-f(i3)
       a2=deter(q(1,i1),q(1,i2),q(1,i3),
     >  q(2,i1),q(2,i2),q(2,i3))
       gradFx=deter(err1,err2,err3,
     >   q(2,i1),q(2,i2),q(2,i3))/a2
       gradFy=deter(q(1,i1),q(1,i2),q(1,i3),
     >  err1,err2,err3)/a2
1      E = E + abs(a2)*(gradFx*gradFx + gradFy*gradFy)/2.
       errH10=E
C
       END
C
C--------------------------------------------------------
       FUNCTION deter (a,c,e,b,d,f)
C--------------------------------------------------------
C
C Calcule le determinant de $(a,b,1 | c,d,1 | e,f,1)$
C 
C
        deter = (a-e)*(d-f) - (b-f)*(c-e)	
       END
