C Fichier: SndMbre.for
C
C---------------------------------------------------
      SUBROUTINE calAire(q,me,nt,ns,aire)
C---------------------------------------------------
C Ce programme calcule l'aire de chaque triangle et la
C stocke dans le tableau aire. Il signale si un  
C triangle est d'aire negative.
C
C     entree: triangulation (ns,nt,q,me)
C     ------- 
C       
C
      DIMENSION q(2,ns), me(3,nt),aire(nt),qq(2,3)
      DO 1 k=1,nt
        DO 2 il=1,3
         i=me(il,k)
         qq(1,il)=q(1,i)
2        qq(2,il)=q(2,i)
       aire(k)=( (qq(1,2)-qq(1,1))*(qq(2,3)-qq(2,1))
     >         - (qq(2,2)-qq(2,1))*(qq(1,3)-qq(1,1)) )/2
      IF(aire(k).LE.0) write(*,*)'L"aire du triangle ',k,
     >                            ' est <=0'
1     CONTINUE
      END
C
C
C----------------------------------------------------------
      SUBROUTINE SndMbre(me,f,ns,nt,aire,ff)
C----------------------------------------------------------
C Calcule le second membre du systeme lineaire 
C associe a l"equation de Laplace et stocke le 
C resultat dans le tableau ff.
C 
C  $ff(i)=\int_\Omega f w^i$
C
C
      DIMENSION f(ns),me(3,nt),aire(nt),ff(ns)
      DIMENSION isuiv(4)
      DATA isuiv/2,3,1,2/
C
      DO 1 j=1,ns
        ff(j)=0.
1     CONTINUE
      DO 2 k = 1,nt
        DO 2 il=1,3
          i=me(il,k)
          ip=me(isuiv(il),k)
          ipp=me(isuiv(il+1),k)
          ff(i)=ff(i)+(2*f(i)+f(ip)+f(ipp))*aire(k)/12.
2     CONTINUE
       END
c
