C Fichier Testgmres.for
      PROGRAMM testgmres
      PARAMETER(NSMAX=400, NAMAX=100*NSMAX)
      IMPLICIT REAL*8 (a-h,o-z)
      DOUBLE PRECISION A(NAMAX),DA(NSMAX),B(NSMAX)
      DOUBLE PRECISION X(NSMAX),C(NSMAX)
      DIMENSION IPL(0:NSMAX),IPC(NAMAX)
      DO 1 I=1,NSMAX
        X(I)=0.D0
1	  CONTINUE
      EPS=1.D-08
      PRINT 100,EPS
100   FORMAT(//,' SEUIL DE CONVERGENCE',D15.6)
C
       nkr = 10
       nit=10*nkr
      WRITE(*,1000)
      WRITE(*,*) 'nkr=',nkr,'nit=',nit
      CALL LECT1(A,DA,IPL,IPC,B,C,N,M,NZA)
      CALL gmres(N,x,eps,nkr,nit,a,da,ipl,ipc,b)
       nkr = 20
       nit=10*nkr
      DO 2 I=1,NSMAX
        X(I)=0.D0
2	  CONTINUE
      WRITE(*,1000)
      WRITE(*,*) 'nkr=',nkr,'nit=',nit
      CALL LECT1(A,DA,IPL,IPC,B,C,N,M,NZA)
      CALL gmres(N,x,eps,nkr,nit,a,da,ipl,ipc,b)
       nkr = 40
       nit=10*nkr
      DO 3 I=1,NSMAX
        X(I)=0.D0
3	  CONTINUE
      WRITE(*,1000)
      WRITE(*,*) 'nkr=',nkr,'nit=',nit
      CALL LECT1(A,DA,IPL,IPC,B,C,N,M,NZA)
      CALL gmres(N,x,eps,nkr,nit,a,da,ipl,ipc,b)
1000  FORMAT(//,1x,80(1H*))
C
      END
C
C
      SUBROUTINE LECT1(A,DA,IPL,IPC,B,C,N,M,NZA)
C
C
C PARAMETRE DE SORTIE:
C -------------------
C N	: RANG DU SYSTEME
C A,DA : MATRICE DU SYSTEME
C IPL,IPC : LES POINTEURS
C B	: SECOND MEMBRE
      DOUBLE PRECISION A(*),DA(*),B(*),C(*)
      DOUBLE PRECISION R,R2,CD,S,C1,C2
      DOUBLE PRECISION SRAND48,DRAND48,XRAND,H,PI
      DIMENSION IPL(0:*),IPC(*),NV(4)
      N = 50
      M = 1
      IA=0
      IPL(0)=IA
C	LA PREMIERE LIGNE
      IA=IA+1
      IPC(IA)=2
      A(IA)=-2.D0
      IPL(1)=IA
      DA(1)=4.D0
C	LES AUTRES LIGNES
      DO 10 I=2,N-1
      IA=IA+1
      IPC(IA)=I-1
      A(IA)=1.D0
      IA=IA+1
      IPC(IA)=I+1
      A(IA)=-2.D0
      IPL(I)=IA
C	LE COEFFICIENT DIAGONAL
      DA(I)=4.D0
10    CONTINUE
C	LA DERNIERE LIGNE
      IA=IA+1
      IPC(IA)=N-1
      A(IA)=1.D0
      IPL(N)=IA
      DA(N)=4.D0
C
      NZA = IPL(N)
C
C	LE SECOND MEMBRE
C	----------------
C
      XRAND = SRAND48()
      DO 30 I=1,N
C	COMPOSANTES ALEATOIRES DANS [-1.,1.]
      XRAND = DRAND48()
      C1 = ( XRAND - .5D0 ) * 2.D0
      XRAND = DRAND48()
      C2 = ( XRAND - .5D0 ) * 2.D0
C	CHOIX DE LA SOLUTION
      C(I) = I*(-1)**i
30    CONTINUE
C     CALL APARX(A,DA,IPL,IPC,C,B)
      ind=0
      CALL pmat(N,C,B,ind,a,da,ipl,ipc,b)
C
C	IMPRESSIONS
C	-----------
C
      PRINT 1500
      PRINT 2000,N,NZA
      NPRINT = 0
      DO 40 I=1,NPRINT
      PRINT 2500,I,(IPC(J),J=IPL(I-1)+1,IPL(I))
      PRINT 3500,I,DA(I),(A(J),J=IPL(I-1)+1,IPL(I))
40    CONTINUE
      PRINT 1500
C
      RETURN
101   FORMAT(1X,5I5)
102   FORMAT(1X,10I7)
103   FORMAT(1X,4E15.8)
1500  FORMAT(//,1X,80(1H*)/,1X,80(1H*))
2000  FORMAT(//,' LECTURE DES DONNEES : TEST1',/1X,19(1H-)//,
     S	1X,'RANG DU SYSTEME',T40,I10/,
     &	1X,'NOMBRE DE COEFFICIENTS NON NULS DE A',T40,I10)
2500  FORMAT(2(/1X,80(1H-)),/1X,'LIGNE',I4,10(/4X,10I6))
3500  FORMAT(/1X,80(1H-)/1X,'LIGNE',I4,' DA',D15.6,' B',D15.6/
     S	,20(10X,2(' A',D15.6)/))
      END

C
C---------------------------------------------
      subroutine gmres(ns,x,eps,nkr,nit,a,da,ipl,ipc,b)
C---------------------------------------------
C
      PARAMETER (nsMax=400,nkrMax=50)
      IMPLICIT REAL*8 (a-h,o-z)
      DOUBLE PRECISION A(*),DA(*),B(*)
      DIMENSION IPL(0:*),IPC(*)
      DIMENSION  x(nsMax),v(nsMax,nkrMax),
     >           h(nkrMax+1,nkrMax),r(nkrMax+1)???
      DIMENSION aux(nsMax),aux1(nsMax)
      CHARACTER*20 nomfic
      DATA zero/1.D-08/
      rec    = zero
C
C...initialisation
C
        ind=1
        CALL pmat(ns,x,aux,ind,a,da,ipl,ipc,b)
        res= prods(ns,aux,aux)
        res= sqrt(res)
        WRITE(*,*) 'residu init=',res
        IF(res .LT. rec) GOTO 4
        rec = max(rec,res*eps)
        WRITE(*,*) 'test arret rec=',rec
C
C...demarrage des iterations
C
      DO 1 it=1,nit
        nk=nkr
C
C...orthogonalisation d'Arnoldi
C
        DO 10 i=1,ns
10        aux(i) = aux(i)/res
        DO 110 i=1,nkr
110        r(i)=0.D0      
        r(1)   = res
C
        DO 11 j=1,nkr
          DO 21 i=1,ns
            v(i,j) = aux(i)
21        CONTINUE
          ind=0
          CALL pmat(ns,aux,aux1,ind,a,da,ipl,ipc,b)
          DO 24 i=1,ns
            aux(i)=aux1(i)
24        CONTINUE
          DO 22 i=1,j
            tem= prods(ns,aux1,v(1,i))
            h(i,j) = tem
            DO 20 il=1,ns
              aux(il)=aux(il)-tem*v(il,i)
 20         CONTINUE
22        CONTINUE
          dem= prods(ns,aux,aux)
          dem=sqrt(dem)
          h(j+1,j) = dem
          IF (dem .LT. rec) THEN
            nk=j
            WRITE(*,*) 'dem=',dem,'nk=',nk
            GOTO 5
          ENDIF
            DO 23 i=1,ns
              aux(i) = aux(i)/dem
23          CONTINUE
11       CONTINUE
C
C...triangularisation et modif. du second membre
C
5       CONTINUE
        DO 31 i=1,nk
          ip=i+1
          hii=h(i,i)
          hipi=h(ip,i)
          gamma=hii*hii+hipi*hipi
          gamma=sqrt(gamma)
          gamma=1.D0/gamma
          cos=hii*gamma
          sin=-hipi*gamma
          DO 41 j=i,nk
            hij=h(i,j)
            hipj=h(ip,j)
            h(i,j) = cos*hij - sin*hipj
            h(ip,j) = sin*hij + cos*hipj
41        CONTINUE
          raux=r(i)
          r(i)=cos*raux
          r(ip)=sin*raux
31        CONTINUE

C
C...resolution du systeme triangulaire superieur
C
        CALL soln(nk,ns,r,h,v,x)

C
C...calcul du residu
C
        ind=1
        CALL pmat(ns,x,aux,ind,a,da,ipl,ipc,b)
        res= prods(ns,aux,aux)
        res= sqrt(res)
        write(*,*) 'it=',it,'res=',res
        IF(res .LT. rec) THEN
          GOTO 4
        ELSEIF(it.GE.nit) THEN
          write(*,*) 'non convergence'
          GOTO 6
        ENDIF
1     CONTINUE
C
C...sortie des resultats
C
4     CONTINUE
      DO 1500 i=1,10
 1500 WRITE(*,*) x(i)
C      write(*,*) 'nom du fichier de stockage de la '
C      write(*,*) 'solution approchee'
C      read(*,'(a)') nomfic
C      CALL ecritF(nomfic,ns,x)
6     CONTINUE
C
C
      END
C
C
C**********************************
C
C     BIBLIOTHEQUE
C
C**********************************
C
C
       INCLUDE 'utilP1.for'
C
C
C
C---------------------------------------------
      SUBROUTINE soln(nk,ns,r,h,v,x)
C---------------------------------------------
C Ce sous-programme resoud le systeme triangulaire
C superieur permettant de calculer la solution
C du probleme de minimisation dans l"algorithme
C GMRES. La solution approchee a l"etape nk est
C calculee et stokee dans le vecteur x.
C
C
      PARAMETER (nsMax=400,nkrMax=50)
      IMPLICIT REAL*8 (a-h,o-z)
      DIMENSION  x(nsMax),v(nsMax,nkrMax),
     >           h(nkrMax,nkrMax),r(nkrMax)
C
      DO 1 i=nk,1,-1
        tem = r(i)/h(i,i)
        r(i)=tem
        DO 2 j=i-1,1,-1
          r(j)=r(j)-h(j,i)*tem

2       CONTINUE
1     CONTINUE
C
      DO 3 i=1,nk
        tem = r(i)
         DO 5 il=1,ns
           x(il)=x(il)+tem*v(il,i)
5        CONTINUE
3     CONTINUE
      END
C
C--------------------------------------
      SUBROUTINE Caxpy(ns,a,x,y)
C--------------------------------------
C Ce sous-programme calcule la combinaison lineaire
C a*x+y, a etant un scalaire, x et y 2 vecteurs de
C taille ns. Le resultat est stocke dans le vecteur y.
C
C
      IMPLICIT REAL*8 (a-h,o-z)
      DIMENSION x(*),y(*)
      DO 1 i=1,ns
1       y(i) = a*x(i) + y(i)
      END
C
C--------------------------------------
      FUNCTION   prods(n,x,y)
C--------------------------------------
C Cette fonction calcule le produit scalaire de 2 vecteurs
C x et y de taille n.
C
C
      IMPLICIT REAL*8 (a-h,o-z)
      DIMENSION x(n),y(n)
      sum = 0.
      DO 1 i=1,n
1       sum = sum + x(i)*y(i)
      prods = sum
      END

C
C
      SUBROUTINE pmat(N,x,ax,ind,a,da,ipl,ipc,b)
C
C
C PARAMETRES D ENTREE :
C ---------------------
C A,DA : LA MATRICE DU SYSTEME
C IPL,IPC : LES POINTEURS ASSOCIES
C X	: VECTEUR A MULTIPLIER
C
C PARAMETRE DE SORTIE:
C -------------------
C ax	: VECTEUR PRODUIT (A) * X si ind = 0
C                     b-A*X si ind=1
C
      IMPLICIT REAL*8 (a-h,o-z)
      DOUBLE PRECISION A(*),DA(N),X(N),ax(N),b(N),S
      DIMENSION IPL(0:N),IPC(*)
C
      DO 10 i=1,N
        ax(i)=0.
 10   CONTINUE
      DO 1 I=1,N
        S=DA(I)*X(I)
        DO 2 K=IPL(I-1)+1,IPL(I)
          S=S+A(K)*X(IPC(K))
2	CONTINUE
        ax(I)=S
1     CONTINUE
      IF(ind.EQ.1) THEN
        DO 3 I=1,N
        ax(i)=b(i)-ax(i)
3       CONTINUE
      ENDIF
C
      RETURN
      END




