C  fichier: evolCHAL.for
C
      PROGRAM evolCHAL
C     ---------------------  
C                             
C Ce programme resout le probleme d"evolution regi
C par l"equation de la chaleur en dimension 1,
C avec conditions aux limites de Dirichlet 
C homogenes et terme source nul, par deux
C methodes: schema explicite, schema implicite
C et factorisation de Gauss de la matrice.
C
C     tableaux:
C     --------- 
C     maillage:
C       x:coordonnees des points du maillage
C     solution
C       phi: valeur de la solution approchee
C     autres tableaux
C       al,d,u: coefficients de la factorisee
C         de Gauss de la matrice du systeme lineaire
C         a resoudre (cas implicite)
C       phin: tableau pour le cas explicite
C
C
C
      PARAMETER (nMax=1000)
      DIMENSION x(nMax),phi(nMax)
      CHARACTER*20 nomfic			
C     
      write(*,*) 'nombre de points (2 mini,1000 maxi)'
      read(*,*) n
      dx=1./(n-1.)
      DO 1 i=1,n
        x(i)=(i-1)*dx
1     CONTINUE
      write(*,*) 'schema choisi:0=explicite'
      write(*,*) '              1=implicite'
      read(*,*) ischem
      write(*,*) 'temps final'
      read(*,*) Tf
      CALL init(n,x,phi)
      IF(isch.EQ.1) THEN
        dtmax=0.5*dx*dx
        write(*,*) 'entrer le pas de temps'
        write(*,*) 'attention dtmax=',dtmax
        read(*,*) dt
        m=aint(Tf/dt)
        c=dt/(dx*dx)
        CALL Sexpli(n,m,c,x,phi)
      ELSE
        write(*,*) 'entrer le pas de temps'
        read(*,*) dt
        m=aint(Tf/dt)
        c=dt/(dx*dx)
        CALL Simpli(n,m,c,x,phi)
      ENDIF
      write(*,*) 'nom du fichier de stockage de la '
      write(*,*) 'solution approchee'
      read(*,'(a)') nomfic
      CALL ecritF(nomfic,n,phi)  
      PAUSE
      END
C
C
C---------------------------------------------------------
      SUBROUTINE init(n,x,phi)
C---------------------------------------------------------
C
      DIMENSION x(*),phi(*)
      DO 1 i=1,n
        xi=x(i)
        phi(i)=xi*(1-xi)
1     CONTINUE
      END
C
C---------------------------------------------------------
      SUBROUTINE Sexpli(n,m,c,x,phi)
C---------------------------------------------------------
C
      PARAMETER (nMax=1000)
      DIMENSION x(*),phi(*),phin(nMax)
      DO 1 k=1,m
        DO 2 i=2,n-1
          phin(i)=phi(i)+c*(phi(i+1)-2*phi(i)+phi(i-1))
2       CONTINUE
        DO 3 i=2,n-1
          phi(i)=phin(i)
3       CONTINUE
1     CONTINUE
      END
C
C---------------------------------------------------------
      SUBROUTINE Simpli(n,m,c,x,phi)
C---------------------------------------------------------
C
      PARAMETER (nMax=1000)
      DIMENSION x(*)
      DIMENSION phi(*)
      DIMENSION al(nMax),d(nMax),u(nMax)
C
C matrice
C
      d2=2*c+1
      d(2)=d2
      u(2)=-c/d2
      DO 1 i=3,n-1
        al(i-1)=-c
        d(i)=2*c+1-u(i-1)*al(i-1)
        u(i)=-c/d(i)
1     CONTINUE
C
C iterations: descente remontee
C
      DO 2 k=1,m
        phi(2)=phi(2)/d(2)
        DO 3 i=3,n-1
          phi(i)=(phi(i)-al(i-1)*phi(i-1))/d(i)
3       CONTINUE
        DO 4 i=n-2,2,-1
          phi(i)=phi(i)-u(i)*phi(i+1)
4       CONTINUE
2     CONTINUE
      END

